/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.41 Revision 1.122
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.41 2009/06/05 09:48:46 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.122 2013/02/02 16:58:00 dilfridge Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# eclass will fail with version older than 2. 14# over time as new EAPI versions are approved.
15 15
16inherit base cmake-utils eutils kde4-functions 16# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
17# @DESCRIPTION:
18# If set to "none", do nothing.
19# For any other value, add selinux to IUSE, and depending on that useflag
20# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
21: ${KDE_SELINUX_MODULE:=none}
17 22
18get_build_type 23# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
24# @DESCRIPTION:
25# If defined, launch and use a private dbus session during src_test.
26
27# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
28# @DESCRIPTION:
29# For proper description see virtualx.eclass manpage.
30# Here we redefine default value to be manual, if your package needs virtualx
31# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
32: ${VIRTUALX_REQUIRED:=manual}
33
34inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils base virtualx versionator eutils multilib
35
19if [[ ${BUILD_TYPE} = live ]]; then 36if [[ ${KDE_BUILD_TYPE} = live ]]; then
37 case ${KDE_SCM} in
20 inherit subversion 38 svn) inherit subversion ;;
39 git) inherit git-2 ;;
40 esac
21fi 41fi
22 42
23EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 43# @ECLASS-VARIABLE: CMAKE_REQUIRED
44# @DESCRIPTION:
45# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
46# Please note that if it's set to 'never' you need to explicitly override following phases:
47# src_configure, src_compile, src_test and src_install.
48# Defaults to 'always'.
49: ${CMAKE_REQUIRED:=always}
50if [[ ${CMAKE_REQUIRED} = always ]]; then
51 buildsystem_eclass="cmake-utils"
52 export_fns="src_configure src_compile src_test src_install"
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements.
60# Note that it is fixed to ${PV} for kde-base packages.
61KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
62
63# Set slot for KDEBASE known packages
64case ${KDEBASE} in
65 kde-base)
66 SLOT=4
67 KDE_MINIMAL="${PV}"
68 ;;
69 kdevelop)
70 if [[ ${KDE_BUILD_TYPE} = live ]]; then
71 # @ECLASS-VARIABLE: KDEVELOP_VERSION
72 # @DESCRIPTION:
73 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
74 # Applies to KDEBASE=kdevelop only.
75 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
76 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
77 # @DESCRIPTION:
78 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only.
80 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
81 else
82 case ${PN} in
83 kdevelop|quanta)
84 KDEVELOP_VERSION=${PV}
85 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
86 ;;
87 kdevplatform|kdevelop-php*)
88 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
89 KDEVPLATFORM_VERSION=${PV}
90 ;;
91 *)
92 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
93 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
94 esac
95 fi
96 SLOT="4"
97 ;;
98esac
99
100inherit ${buildsystem_eclass}
101
102EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
103
104unset buildsystem_eclass
105unset export_fns
106
107# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
108# @DESCRIPTION:
109# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
110# This variable must be set before inheriting any eclasses. Defaults to 'never'.
111DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
112
113# @ECLASS-VARIABLE: QTHELP_REQUIRED
114# @DESCRIPTION:
115# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
116# This variable must be set before inheriting any eclasses. Defaults to 'never'.
117QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
24 118
25# @ECLASS-VARIABLE: OPENGL_REQUIRED 119# @ECLASS-VARIABLE: OPENGL_REQUIRED
26# @DESCRIPTION: 120# @DESCRIPTION:
27# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 121# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
28# This variable must be set before inheriting any eclasses. Defaults to 'never'. 122# This variable must be set before inheriting any eclasses. Defaults to 'never'.
29OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 123OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
30 124
31# @ECLASS-VARIABLE: WEBKIT_REQUIRED 125# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
32# @DESCRIPTION: 126# @DESCRIPTION:
33# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'. 127# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
34# This variable must be set before inheriting any eclasses. Defaults to 'never'. 128# This variable must be set before inheriting any eclasses. Defaults to 'never'.
35WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}" 129MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
36 130
37# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 131# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
38# @DESCRIPTION: 132# @DESCRIPTION:
39# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 133# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
40# This variable must be set before inheriting any eclasses. Defaults to 'never'. 134# This variable must be set before inheriting any eclasses. Defaults to 'never'.
42 136
43# @ECLASS-VARIABLE: KDE_REQUIRED 137# @ECLASS-VARIABLE: KDE_REQUIRED
44# @DESCRIPTION: 138# @DESCRIPTION:
45# Is kde required? Possible values are 'always', 'optional' and 'never'. 139# Is kde required? Possible values are 'always', 'optional' and 'never'.
46# This variable must be set before inheriting any eclasses. Defaults to 'always' 140# This variable must be set before inheriting any eclasses. Defaults to 'always'
47# If set to always or optional, KDE_MINIMAL may be overriden as well. 141# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
48# Note that for kde-base packages this variable is fixed to 'always'. 142# Note that for kde-base packages this variable is fixed to 'always'.
49KDE_REQUIRED="${KDE_REQUIRED:-always}" 143KDE_REQUIRED="${KDE_REQUIRED:-always}"
50 144
51# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here) 145# @ECLASS-VARIABLE: KDE_HANDBOOK
52if [[ -n ${KDE_MINIMAL} ]]; then 146# @DESCRIPTION:
53 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do 147# Set to enable handbook in application. Possible values are 'always', 'optional'
54 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break 148# (handbook USE flag) and 'never'.
55 done 149# This variable must be set before inheriting any eclasses. Defaults to 'never'.
56 unset slot 150# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
57 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL 151# ensures buildtime and runtime dependencies.
152KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
153
154# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
155# @DESCRIPTION:
156# Set this varible if you want your live package to manage its
157# translations. (Mostly all kde ebuilds does not ship documentation
158# and translations in live ebuilds)
159if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
160 # Kdebase actualy provides the handbooks even for live stuff
161 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
162 KDE_LINGUAS=""
163fi
164
165# Setup packages inheriting this eclass
166case ${KDEBASE} in
167 kde-base)
168 HOMEPAGE="http://www.kde.org/"
169 LICENSE="GPL-2"
170 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
171 # Disable tests for live ebuilds by default
172 RESTRICT+=" test"
173 fi
174
175 # This code is to prevent portage from searching GENTOO_MIRRORS for
176 # packages that will never be mirrored. (As they only will ever be in
177 # the overlay).
178 case ${PV} in
179 *9999* | 4.?.[6-9]?)
180 RESTRICT+=" mirror"
181 ;;
182 esac
183 ;;
184 kdevelop)
185 HOMEPAGE="http://www.kdevelop.org/"
186 LICENSE="GPL-2"
187 ;;
188esac
189
190# @ECLASS-VARIABLE: QT_MINIMAL
191# @DESCRIPTION:
192# Determine version of qt we enforce as minimal for the package.
193if version_is_at_least 4.8.50 "${KDE_MINIMAL}"; then
194 # Upstream has added an *undeclared* dependency on Qt 4.8...
195 QT_MINIMAL="${QT_MINIMAL:-4.8.0}"
58else 196else
59 KDE_MINIMAL_VALID=1 197 QT_MINIMAL="${QT_MINIMAL:-4.7.4}"
60fi 198fi
61 199
62# @ECLASS-VARIABLE: KDE_MINIMAL 200# Declarative dependencies
63# @DESCRIPTION: 201qtdeclarativedepend="
64# This wariable is used when KDE_REQUIRED is set, to specify required KDE minimal 202 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
65# version for apps to work. Currently defaults to 4.2 203"
66# One may override this variable to raise version requirements. 204case ${DECLARATIVE_REQUIRED} in
67# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables. 205 always)
68# Note that for kde-base packages is fixed to ${SLOT}. 206 COMMONDEPEND+=" ${qtdeclarativedepend}"
69KDE_MINIMAL="${KDE_MINIMAL:-4.2}"
70
71# Fallback behaviour (for now)
72# TODO Remove when tree is clean
73if [[ -n ${NEED_KDE} ]]; then
74 case ${NEED_KDE} in
75 none)
76 KDE_REQUIRED="never"
77 ;; 207 ;;
78 *) 208 optional)
79 KDE_REQUIRED="always" 209 IUSE+=" declarative"
80 KDE_MINIMAL="${NEED_KDE}" 210 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
81 ;; 211 ;;
212 *) ;;
82 esac 213esac
83fi 214unset qtdeclarativedepend
84 215
85# @ECLASS-VARIABLE: QT_DEPEND 216# QtHelp dependencies
86# @DESCRIPTION: 217qthelpdepend="
87# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1.. 218 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
88# Currently defaults to 4.5.1 219"
89QT_DEPEND="${QT_DEPEND:-4.5.1}" 220case ${QTHELP_REQUIRED} in
221 always)
222 COMMONDEPEND+=" ${qthelpdepend}"
223 ;;
224 optional)
225 IUSE+=" qthelp"
226 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
227 ;;
228esac
229unset qthelpdepend
90 230
91# OpenGL dependencies 231# OpenGL dependencies
92qtopengldepend=" 232qtopengldepend="
93 >=x11-libs/qt-opengl-${QT_DEPEND}:4 233 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
94" 234"
95case ${OPENGL_REQUIRED} in 235case ${OPENGL_REQUIRED} in
96 always) 236 always)
97 COMMONDEPEND="${COMMONDEPEND} ${qtopengldepend}" 237 COMMONDEPEND+=" ${qtopengldepend}"
98 ;; 238 ;;
99 optional) 239 optional)
100 IUSE="${IUSE} opengl" 240 IUSE+=" opengl"
101 COMMONDEPEND="${COMMONDEPEND}
102 opengl? ( ${qtopengldepend} ) 241 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
103 "
104 ;; 242 ;;
105 *) ;; 243 *) ;;
106esac 244esac
107unset qtopengldepend 245unset qtopengldepend
108 246
109# WebKit dependencies 247# MultiMedia dependencies
110qtwebkitdepend=" 248qtmultimediadepend="
111 >=x11-libs/qt-webkit-${QT_DEPEND}:4 249 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
112" 250"
113case ${WEBKIT_REQUIRED} in 251case ${MULTIMEDIA_REQUIRED} in
114 always) 252 always)
115 COMMONDEPEND="${COMMONDEPEND} ${qtwebkitdepend}" 253 COMMONDEPEND+=" ${qtmultimediadepend}"
116 ;; 254 ;;
117 optional) 255 optional)
118 IUSE="${IUSE} webkit" 256 IUSE+=" multimedia"
119 COMMONDEPEND="${COMMONDEPEND} 257 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
120 webkit? ( ${qtwebkitdepend} )
121 "
122 ;; 258 ;;
123 *) ;; 259 *) ;;
124esac 260esac
125unset qtwebkitdepend 261unset qtmultimediadepend
126 262
127# CppUnit dependencies 263# CppUnit dependencies
128cppuintdepend=" 264cppuintdepend="
129 dev-util/cppunit 265 dev-util/cppunit
130" 266"
131case ${CPPUNIT_REQUIRED} in 267case ${CPPUNIT_REQUIRED} in
132 always) 268 always)
133 DEPEND="${DEPEND} ${cppuintdepend}" 269 DEPEND+=" ${cppuintdepend}"
134 ;; 270 ;;
135 optional) 271 optional)
136 IUSE="${IUSE} test" 272 IUSE+=" test"
137 DEPEND="${DEPEND}
138 test? ( ${cppuintdepend} ) 273 DEPEND+=" test? ( ${cppuintdepend} )"
139 "
140 ;; 274 ;;
141 *) ;; 275 *) ;;
142esac 276esac
143unset cppuintdepend 277unset cppuintdepend
144 278
145# DEPRECATED block
146if [[ ${NEED_KDE} != "none" ]]; then
147 # localization deps
148 # DISABLED UNTIL PMS decide correct approach :(
149 if [[ -n ${KDE_LINGUAS} ]]; then
150 LNG_DEP=""
151 for _lng in ${KDE_LINGUAS}; do
152 # there must be or due to issue if lingua is not present in kde-l10n so
153 # it wont die but pick kde-l10n as-is.
154 LNG_DEP="${LNG_DEP}
155 || (
156 kde-base/kde-l10n[linguas_${_lng},kdeprefix=]
157 kde-base/kde-l10n[kdeprefix=]
158 )
159 "
160 done
161 fi
162fi # NEED_KDE != NONE block
163
164# Setup packages inheriting this eclass
165case ${KDEBASE} in
166 kde-base)
167 if [[ $BUILD_TYPE = live ]]; then
168 # Disable tests for live ebuilds
169 RESTRICT="${RESTRICT} test"
170 # Live ebuilds in kde-base default to kdeprefix by default
171 IUSE="${IUSE} +kdeprefix"
172 else
173 # All other ebuild types default to -kdeprefix as before
174 IUSE="${IUSE} kdeprefix"
175 fi
176 # Determine SLOT from PVs
177 case ${PV} in
178 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
179 4.3* | 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) SLOT="4.3" ;;
180 4.2* | 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6*) SLOT="4.2" ;;
181 9999*) SLOT="live" ;; # regular live
182 *) die "Unsupported ${PV}" ;;
183 esac
184 _kdedir="${SLOT}"
185 _pv="-${PV}:${SLOT}"
186 _pvn="-${PV}"
187
188 # Block installation of other SLOTS unless kdeprefix
189 for slot in ${KDE_SLOTS[@]}; do
190 # Block non kdeprefix ${PN} on other slots
191 if [[ ${SLOT} != ${slot} ]]; then
192 RDEPEND="${RDEPEND}
193 !kdeprefix? ( !kde-base/${PN}:${slot}[-kdeprefix] )
194 "
195 fi
196 done
197 unset slot
198 ;;
199 koffice)
200 SLOT="2"
201 _pv="-${KDE_MINIMAL}"
202 _pvn="${_pv}"
203 ;;
204 *)
205 _pv="-${KDE_MINIMAL}"
206 _pvn="${_pv}"
207 ;;
208
209esac
210
211# KDE dependencies 279# KDE dependencies
280# Qt accessibility classes are needed in various places, bug 325461
212kdecommondepend=" 281kdecommondepend="
213 dev-lang/perl 282 dev-lang/perl
283 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
284 >=x11-libs/qt-dbus-${QT_MINIMAL}:4
285 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
286 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility]
287 >=x11-libs/qt-script-${QT_MINIMAL}:4
288 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
289 >=x11-libs/qt-svg-${QT_MINIMAL}:4
290 >=x11-libs/qt-test-${QT_MINIMAL}:4
291 >=x11-libs/qt-webkit-${QT_MINIMAL}:4
292 !aqua? (
214 x11-libs/libXext 293 x11-libs/libXext
215 x11-libs/libXt 294 x11-libs/libXt
216 x11-libs/libXxf86vm 295 x11-libs/libXxf86vm
217 >=x11-libs/qt-core-${QT_DEPEND}:4[qt3support,ssl] 296 x11-libs/libXcomposite
218 >=x11-libs/qt-gui-${QT_DEPEND}:4[accessibility,dbus] 297 x11-libs/libxkbfile
219 >=x11-libs/qt-qt3support-${QT_DEPEND}:4[accessibility] 298 )
220 >=x11-libs/qt-script-${QT_DEPEND}:4
221 >=x11-libs/qt-sql-${QT_DEPEND}:4[qt3support]
222 >=x11-libs/qt-svg-${QT_DEPEND}:4
223 >=x11-libs/qt-test-${QT_DEPEND}:4
224" 299"
300
225if [[ ${PN} != kdelibs ]]; then 301if [[ ${PN} != kdelibs ]]; then
302 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
226 if [[ ${KDEBASE} = kde-base ]]; then 303 if [[ ${KDEBASE} = kdevelop ]]; then
227 kdecommondepend="${kdecommondepend} 304 if [[ ${PN} != kdevplatform ]]; then
228 kdeprefix? ( >=kde-base/kdelibs${_pv}[kdeprefix] ) 305 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
229 !kdeprefix? ( >=kde-base/kdelibs${_pvn}[-kdeprefix] ) 306 # @DESCRIPTION:
307 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
308 # Applies to KDEBASE=kdevelop only.
309 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
310 case ${KDEVPLATFORM_REQUIRED} in
311 always)
312 kdecommondepend+="
313 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
314 "
315 ;;
316 *) ;;
317 esac
318 fi
319 fi
320fi
321
322kdedepend="
323 dev-util/automoc
324 virtual/pkgconfig
325 !aqua? (
326 >=x11-libs/libXtst-1.1.0
327 x11-proto/xf86vidmodeproto
328 )
329"
330
331kderdepend=""
332
333# all packages needs oxygen icons for basic iconset
334if [[ ${PN} != oxygen-icons ]]; then
335 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
336fi
337
338# add a dependency over kde-l10n if EAPI4 or better is around
339if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
340 for _lingua in ${KDE_LINGUAS}; do
341 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
342 # but only for selected ones.
343 # this can't be done on one line because if user doesn't use any localisation
344 # then he is probably not interested in kde-l10n at all.
345 kderdepend+="
346 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
230 " 347 "
231 else 348 done
232 kdecommondepend="${kdecommondepend} 349 unset _lingua
233 >=kde-base/kdelibs${_pv}
234 "
235 fi
236fi 350fi
237unset _pv _pvn 351
238kdedepend=" 352kdehandbookdepend="
239 dev-util/pkgconfig 353 app-text/docbook-xml-dtd:4.2
240 >=sys-apps/sandbox-1.3.2 354 app-text/docbook-xsl-stylesheets
241" 355"
356kdehandbookrdepend="
357 $(add_kdebase_dep kdelibs 'handbook')
358"
359case ${KDE_HANDBOOK} in
360 always)
361 kdedepend+=" ${kdehandbookdepend}"
362 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
363 ;;
364 optional)
365 IUSE+=" +handbook"
366 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
367 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
368 ;;
369 *) ;;
370esac
371unset kdehandbookdepend kdehandbookrdepend
372
373case ${KDE_SELINUX_MODULE} in
374 none) ;;
375 *)
376 IUSE+=" selinux"
377 kdecommondepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
378 ;;
379esac
380
242case ${KDE_REQUIRED} in 381case ${KDE_REQUIRED} in
243 always) 382 always)
244 COMMONDEPEND="${COMMONDEPEND} ${kdecommondepend}" 383 IUSE+=" aqua"
245 DEPEND="${DEPEND} ${kdedepend}" 384 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
385 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
386 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
246 ;; 387 ;;
247 optional) 388 optional)
248 IUSE="${IUSE} kde" 389 IUSE+=" aqua kde"
249 COMMONDEPEND="${COMMONDEPEND} 390 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
250 kde? ( ${kdecommondepend} )" 391 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
251 DEPEND="${DEPEND} 392 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
252 kde? ( ${kdedepend} )"
253 ;; 393 ;;
254 *) ;; 394 *) ;;
255esac 395esac
396
256unset kdecommondepend kdedepend 397unset kdecommondepend kdedepend kderdepend
257 398
258debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}" 399debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
259debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}" 400debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
260debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}" 401debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
261 402
262# Accumulate dependencies set by this eclass 403# Accumulate dependencies set by this eclass
263DEPEND="${DEPEND} ${COMMONDEPEND}" 404DEPEND+=" ${COMMONDEPEND}"
264RDEPEND="${RDEPEND} ${COMMONDEPEND}" 405RDEPEND+=" ${COMMONDEPEND}"
406unset COMMONDEPEND
265 407
266# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 408# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
267# koffice ebuild, the URI should be set in the ebuild itself 409# kdevelop ebuild, the URI should be set in the ebuild itself
268case ${BUILD_TYPE} in 410_calculate_src_uri() {
269 live) 411 debug-print-function ${FUNCNAME} "$@"
270 # Determine branch URL based on live type 412
271 local branch_prefix 413 local _kmname _kmname_pv
414
415 # we calculate URI only for known KDEBASE modules
416 [[ -n ${KDEBASE} ]] || return
417
418 # calculate tarball module name
419 if [[ -n ${KMNAME} ]]; then
420 # fixup kdebase-apps name
272 case ${PV} in 421 case ${KMNAME} in
273 9999*) 422 kdebase-apps)
274 # trunk 423 _kmname="kdebase" ;;
275 branch_prefix="trunk/KDE"
276 ;;
277 *) 424 *)
278 # branch 425 _kmname="${KMNAME}" ;;
279 branch_prefix="branches/KDE/${SLOT}"
280 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
281 # @DESCRIPTION
282 # Suffix appended to ESVN_PROJECT depending on fetched branch.
283 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
284 ESVN_PROJECT_SUFFIX="-${PV}"
285 ;;
286 esac 426 esac
427 else
428 _kmname=${PN}
429 fi
430 _kmname_pv="${_kmname}-${PV}"
431 case ${KDEBASE} in
432 kde-base)
433 case ${PV} in
434 4.4.11.1)
435 # KDEPIM 4.4, special case
436 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
437 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
438 4.[89].8[05] | 4.[89].9[0235678])
439 # Unstable KDE SC releases
440 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
441 4.[1234567].[12345])
442 # Stable KDE SC with old .bz2 support
443 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
444 *)
445 # Stable KDE SC releases
446 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
447 esac
448 ;;
449 kdevelop|kdevelop-php*|kdevplatform)
450 case ${KDEVELOP_VERSION} in
451 4.[12].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
452 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2" ;;
453 esac
454 ;;
455 esac
456}
457
458_calculate_live_repo() {
459 debug-print-function ${FUNCNAME} "$@"
460
287 SRC_URI="" 461 SRC_URI=""
288 # @ECLASS-VARIABLE: ESVN_MIRROR 462 case ${KDE_SCM} in
289 # @DESCRIPTION: 463 svn)
290 # This variable allows easy overriding of default kde mirror service 464 # Determine branch URL based on live type
291 # (anonsvn) with anything else you might want to use. 465 local branch_prefix
292 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
293 # Split ebuild, or extragear stuff
294 if [[ -n ${KMNAME} ]]; then
295 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
296 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
297 KMMODULE="${PN}"
298 fi
299 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
300 case ${KMNAME} in 466 case ${PV} in
301 kdebase-*) 467 9999*)
302 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}" 468 # trunk
303 ;; 469 branch_prefix="trunk/KDE"
304 kdereview)
305 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
306 ;;
307 kdesupport)
308 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
309 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
310 ;;
311 kde*)
312 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
313 ;;
314 extragear*|playground*)
315 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
316 # build packages from same svn location.
317 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
318 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
319 ;;
320 koffice)
321 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
322 ;; 470 ;;
323 *) 471 *)
324 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 472 # branch
473 branch_prefix="branches/KDE/$(get_kde_version)"
474 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
475 # @DESCRIPTION
476 # Suffix appended to ESVN_PROJECT depending on fetched branch.
477 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
478 ESVN_PROJECT_SUFFIX="-${PV}"
325 ;; 479 ;;
326 esac 480 esac
327 else
328 # kdelibs, kdepimlibs
329 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
330 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
331 fi
332 # @ECLASS-VARIABLE: ESVN_UP_FREQ 481 # @ECLASS-VARIABLE: ESVN_MIRROR
333 # @DESCRIPTION: 482 # @DESCRIPTION:
334 # This variable is used for specifying the timeout between svn synces 483 # This variable allows easy overriding of default kde mirror service
335 # for kde-base and koffice modules. Does not affect misc apps. 484 # (anonsvn) with anything else you might want to use.
336 # Default value is 1 hour. 485 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
337 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 486 # Split ebuild, or extragear stuff
338 ;;
339 *)
340 if [[ -n ${KDEBASE} ]]; then
341 if [[ -n ${KMNAME} ]]; then 487 if [[ -n ${KMNAME} ]]; then
488 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
489 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
490 KMMODULE="${PN}"
491 fi
492 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
342 case ${KMNAME} in 493 case ${KMNAME} in
343 kdebase-apps) 494 kdebase-*)
344 _kmname="kdebase" ;; 495 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
496 ;;
497 kdelibs-*)
498 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
499 ;;
500 kdereview*)
501 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
502 ;;
503 kdesupport)
504 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
505 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
506 ;;
507 kde*)
508 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
509 ;;
510 extragear*|playground*)
511 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
512 # build packages from same svn location.
513 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
514 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
515 ;;
345 *) 516 *)
346 _kmname="${KMNAME}" ;; 517 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
518 ;;
347 esac 519 esac
520 else
521 # kdelibs, kdepimlibs
522 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
523 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
524 fi
525 # @ECLASS-VARIABLE: ESVN_UP_FREQ
526 # @DESCRIPTION:
527 # This variable is used for specifying the timeout between svn synces
528 # for kde-base modules. Does not affect misc apps.
529 # Default value is 1 hour.
530 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
531 ;;
532 git)
533 local _kmname
534 # @ECLASS-VARIABLE: EGIT_MIRROR
535 # @DESCRIPTION:
536 # This variable allows easy overriding of default kde mirror service
537 # (anongit) with anything else you might want to use.
538 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
539
540 # @ECLASS-VARIABLE: EGIT_REPONAME
541 # @DESCRIPTION:
542 # This variable allows overriding of default repository
543 # name. Specify only if this differ from PN and KMNAME.
544 if [[ -n ${EGIT_REPONAME} ]]; then
545 # the repository and kmname different
546 _kmname=${EGIT_REPONAME}
547 elif [[ -n ${KMNAME} ]]; then
548 _kmname=${KMNAME}
348 else 549 else
349 _kmname=${PN} 550 _kmname=${PN}
350 fi 551 fi
351 _kmname_pv="${_kmname}-${PV}" 552
352 if [[ $NEED_KDE != live ]]; then 553 # default branching
353 case ${KDEBASE} in 554 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
354 kde-base) 555 EGIT_BRANCH="KDE/$(get_kde_version)"
355 case ${PV} in 556
356 4.2.85|4.2.90) 557 # default repo uri
357 # block for normally packed unstable releases 558 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
358 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 559
359 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 560 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
360 SRC_URI="http://dev.gentooexperimental.org/~alexxy/kde/${PV}/${_kmname_pv}.tar.lzma" ;; 561 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
361 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6* | 4.0.9* | 4.0.8*)
362 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
363 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;;
364 esac
365 ;;
366 koffice)
367 case ${PV} in
368 1.9*)
369 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2"
370 ;;
371 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" ;;
372 esac
373 ;; 562 ;;
374 esac 563 esac
375 fi 564}
376 unset _kmname _kmname_pv 565
377 fi 566case ${KDE_BUILD_TYPE} in
378 ;; 567 live) _calculate_live_repo ;;
568 *) _calculate_src_uri ;;
379esac 569esac
380 570
381debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 571debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
382 572
383# @ECLASS-VARIABLE: PREFIX 573# @ECLASS-VARIABLE: PREFIX
384# @DESCRIPTION: 574# @DESCRIPTION:
385# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 575# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
386# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 576# kde-base packages go into KDE4 installation directory (/usr).
387# No matter the PREFIX, package will be built agains KDE installed in KDEDIR. 577# No matter the PREFIX, package will be built against KDE installed in /usr.
388 578
389# @FUNCTION: kde4-base_pkg_setup 579# @FUNCTION: kde4-base_pkg_setup
390# @DESCRIPTION: 580# @DESCRIPTION:
391# Do the basic kdeprefix KDEDIR settings and determine with which kde should 581# Do some basic settings
392# optional applications link
393kde4-base_pkg_setup() { 582kde4-base_pkg_setup() {
394 debug-print-function ${FUNCNAME} "$@" 583 debug-print-function ${FUNCNAME} "$@"
395 584
396 # QA ebuilds 585 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
397 case ${NEED_KDE} in 586 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
398 none) ewarn "QA Notice: using deprecated NEED_KDE variable, use KDE_REQUIRED=\"never\" or KDE_REQUIRED=\"optional\" instead. You may want to override KDE_MINIMAL as well (default is KDE_MINIMAL=\"${KDE_MINIMAL}\")." ;; 587 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
399 *) [[ -n ${NEED_KDE} ]] && ewarn "QA Notice: using deprecated NEED_KDE variable, use KDE_MINIMAL instead (default is KDE_MINIMAL=\"${KDE_MINIMAL}\")." ;; 588 fi
400 esac
401 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
402 589
403 # Don't set KDEHOME during compilation, it will cause access violations 590 # Don't set KDEHOME during compilation, it will cause access violations
404 unset KDEHOME 591 unset KDEHOME
405 592
406 if [[ ${KDEBASE} = kde-base ]]; then 593 # Check if gcc compiler is fresh enough.
407 if use kdeprefix; then 594 # In theory should be in pkg_pretend but we check it only for kdelibs there
408 KDEDIR="${ROOT}usr/kde/${_kdedir}" 595 # and for others we do just quick scan in pkg_setup because pkg_pretend
409 else 596 # executions consume quite some time.
410 KDEDIR="${ROOT}usr" 597 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
598 # is otherwise undefined.
599 if [[ ${EAPI:-0} != 3 ]]; then
600 if [[ ${MERGE_TYPE} != binary ]]; then
601 [[ $(gcc-major-version) -lt 4 ]] || \
602 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
603 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
411 fi 604 fi
412 PREFIX="${PREFIX:-${KDEDIR}}"
413 else
414 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
415 KDEDIR=
416 local kde_minimal_met
417 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
418 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
419 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
420 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
421 KDEDIR="${ROOT}usr/kde/${slot}"
422 else
423 KDEDIR="${ROOT}usr"
424 fi
425 break;
426 fi
427 done
428 unset slot
429
430 # Bail out if kdelibs required but not found
431 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
432 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
433 else
434 [[ -z ${KDEDIR} ]] && KDEDIR="${ROOT}usr"
435 fi 605 fi
436 606
437 PREFIX="${PREFIX:-${ROOT}usr}" 607 KDEDIR=/usr
438 fi 608 : ${PREFIX:=/usr}
609 EKDEDIR=${EPREFIX}/usr
439 610
440 # Not needed anymore 611 # Point to correct QT plugins path
441 unset _kdedir 612 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
613
614 # Fix XDG collision with sandbox
615 export XDG_CONFIG_HOME="${T}"
442} 616}
443 617
444# @FUNCTION: kde4-base_src_unpack 618# @FUNCTION: kde4-base_src_unpack
445# @DESCRIPTION: 619# @DESCRIPTION:
446# This function unpacks the source tarballs for KDE4 applications. 620# This function unpacks the source tarballs for KDE4 applications.
447kde4-base_src_unpack() { 621kde4-base_src_unpack() {
448 debug-print-function ${FUNCNAME} "$@" 622 debug-print-function ${FUNCNAME} "$@"
449 623
450 if [[ ${BUILD_TYPE} = live ]]; then 624 if [[ ${KDE_BUILD_TYPE} = live ]]; then
625 case ${KDE_SCM} in
626 svn)
451 migrate_store_dir 627 migrate_store_dir
452 subversion_src_unpack 628 subversion_src_unpack
629 ;;
630 git)
631 git-2_src_unpack
632 ;;
633 esac
453 else 634 else
454 base_src_unpack 635 unpack ${A}
455 fi 636 fi
456} 637}
457 638
458# @FUNCTION: kde4-base_src_compile 639# @FUNCTION: kde4-base_src_prepare
459# @DESCRIPTION: 640# @DESCRIPTION:
460# General pre-configure and pre-compile function for KDE4 applications. 641# General pre-configure and pre-compile function for KDE4 applications.
461# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 642# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
643# enable_selected_linguas() and enable_selected_doc_linguas()
462# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 644# in kde4-functions.eclass(5) for further details.
463kde4-base_src_prepare() { 645kde4-base_src_prepare() {
464 debug-print-function ${FUNCNAME} "$@" 646 debug-print-function ${FUNCNAME} "$@"
647
648 # enable handbook and linguas only when not using live ebuild
465 649
466 # Only enable selected languages, used for KDE extragear apps. 650 # Only enable selected languages, used for KDE extragear apps.
467 if [[ -n ${KDE_LINGUAS} ]]; then 651 if [[ -n ${KDE_LINGUAS} ]]; then
468 enable_selected_linguas 652 enable_selected_linguas
469 fi 653 fi
470 654
471 [[ ${BUILD_TYPE} = live ]] && subversion_src_prepare 655 # Enable/disable handbooks for kde4-base packages
656 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
657 # kdelibs inherits kde4-base but handle installing the handbook itself
658 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
659 if [[ ${KDEBASE} == kde-base ]]; then
660 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
661 # documentation in kde4-functions
662 : ${KDE_DOC_DIRS:=doc}
663 local dir
664 for dir in ${KDE_DOC_DIRS}; do
665 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
666 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
667 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
668 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
669 -i CMakeLists.txt || die "failed to comment out handbook"
670 done
671 fi
672 else
673 enable_selected_doc_linguas
674 fi
675 fi
676
677 # SCM bootstrap
678 if [[ ${KDE_BUILD_TYPE} = live ]]; then
679 case ${KDE_SCM} in
680 svn) subversion_src_prepare ;;
681 esac
682 fi
683
684 # Apply patches
472 base_src_prepare 685 base_src_prepare
473 686
474 # Save library dependencies 687 # Save library dependencies
475 if [[ -n ${KMSAVELIBS} ]] ; then 688 if [[ -n ${KMSAVELIBS} ]] ; then
476 save_library_dependencies 689 save_library_dependencies
478 691
479 # Inject library dependencies 692 # Inject library dependencies
480 if [[ -n ${KMLOADLIBS} ]] ; then 693 if [[ -n ${KMLOADLIBS} ]] ; then
481 load_library_dependencies 694 load_library_dependencies
482 fi 695 fi
696
697 # Hack for manuals relying on outdated DTD, only outside kde-base/...
698 if [[ -z ${KDEBASE} ]]; then
699 find "${S}" -name "*.docbook" \
700 -exec sed -i -r \
701 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
702 || die 'failed to fix DocBook variant version'
703 fi
483} 704}
484 705
485# @FUNCTION: kde4-base_src_configure 706# @FUNCTION: kde4-base_src_configure
486# @DESCRIPTION: 707# @DESCRIPTION:
487# Function for configuring the build of KDE4 applications. 708# Function for configuring the build of KDE4 applications.
488kde4-base_src_configure() { 709kde4-base_src_configure() {
489 debug-print-function ${FUNCNAME} "$@" 710 debug-print-function ${FUNCNAME} "$@"
490 711
712 # Build tests in src_test only, where we override this value
713 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
714
715 if use_if_iuse debug; then
716 # Set "real" debug mode
717 CMAKE_KDE_BUILD_TYPE="Debugfull"
718 else
491 # Handle common release builds 719 # Handle common release builds
492 if ! has debug ${IUSE//+} || ! use debug; then
493 append-cppflags -DQT_NO_DEBUG 720 append-cppflags -DQT_NO_DEBUG
494 fi 721 fi
495 722
496 # Build tests in src_test only, where we override this value
497 local cmakeargs="-DKDE4_BUILD_TESTS=OFF"
498
499 # set "real" debug mode
500 if has debug ${IUSE//+} && use debug; then
501 CMAKE_BUILD_TYPE="Debugfull"
502 fi
503
504 # Set distribution name 723 # Set distribution name
505 [[ ${PN} = kdelibs ]] && cmakeargs="${cmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo" 724 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
506 725
507 # Here we set the install prefix 726 # Here we set the install prefix
508 cmakeargs="${cmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}" 727 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
509 728
510 # Set environment 729 # Use colors
511 QTEST_COLORED=1 730 QTEST_COLORED=1
512 QT_PLUGIN_PATH="${KDEDIR}/$(get_libdir)/kde4/plugins/"
513 731
514 # Point pkg-config path to KDE *.pc files
515 export PKG_CONFIG_PATH="${KDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
516
517 # Shadow existing /usr installations 732 # Shadow existing installations
518 unset KDEDIRS 733 unset KDEDIRS
519 734
520 if [[ ${KDEDIR} != "${ROOT}usr" ]]; then 735 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
521 # Override some environment variables - only when kdeprefix is different, 736 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
522 # to not break ccache/distcc 737 #kde-config -path data unavailable when cross-compiling
523 PATH="${KDEDIR}/bin:${PATH}" 738 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
524 LDPATH="${KDEDIR}/$(get_libdir):${LDPATH}"
525 739
526 # Append full RPATH 740 # sysconf needs to be /etc, not /usr/etc
527 cmakeargs="${cmakeargs} -DCMAKE_SKIP_RPATH=OFF" 741 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
742
743 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
744 if [[ ${mycmakeargs} ]]; then
745 eqawarn "mycmakeargs should always be declared as an array, not a string"
528 fi 746 fi
529 747 mycmakeargs=(${mycmakeargs})
530 if has kdeprefix ${IUSE//+} && use kdeprefix; then
531 # Set cmake prefixes to allow buildsystem to localize valid KDE installation
532 # when more are present
533 cmakeargs="${cmakeargs} -DCMAKE_SYSTEM_PREFIX_PATH=${KDEDIR}"
534 else
535 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
536 cmakeargs="${cmakeargs} -DSYSCONF_INSTALL_DIR=${ROOT}etc"
537 fi 748 fi
538 749
539 mycmakeargs="${cmakeargs} ${mycmakeargs}" 750 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
540 751
541 cmake-utils_src_configure 752 cmake-utils_src_configure
542} 753}
543 754
544# @FUNCTION: kde4-base_src_compile 755# @FUNCTION: kde4-base_src_compile
545# @DESCRIPTION: 756# @DESCRIPTION:
546# General function for compiling KDE4 applications. 757# General function for compiling KDE4 applications.
547kde4-base_src_compile() { 758kde4-base_src_compile() {
548 debug-print-function ${FUNCNAME} "$@" 759 debug-print-function ${FUNCNAME} "$@"
549 760
550 cmake-utils_src_compile 761 cmake-utils_src_compile "$@"
551} 762}
552 763
553# @FUNCTION: kde4-base_src_test 764# @FUNCTION: kde4-base_src_test
554# @DESCRIPTION: 765# @DESCRIPTION:
555# Function for testing KDE4 applications. 766# Function for testing KDE4 applications.
556kde4-base_src_test() { 767kde4-base_src_test() {
557 debug-print-function ${FUNCNAME} "$@" 768 debug-print-function ${FUNCNAME} "$@"
558 769
770 local kded4_pid
771
772 _test_runner() {
773 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
774 export $(dbus-launch)
775 kded4 2>&1 > /dev/null &
776 kded4_pid=$!
777 fi
778
779 cmake-utils_src_test
780 }
781
782 # When run as normal user during ebuild development with the ebuild command, the
783 # kde tests tend to access the session DBUS. This however is not possible in a real
784 # emerge or on the tinderbox.
785 # > make sure it does not happen, so bad tests can be recognized and disabled
786 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
787
559 # Override this value, set in kde4-base_src_configure() 788 # Override this value, set in kde4-base_src_configure()
560 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 789 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
561 cmake-utils_src_configure 790 cmake-utils_src_configure
562 kde4-base_src_compile 791 kde4-base_src_compile
563 792
564 cmake-utils_src_test 793 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
794 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
795 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
796 # surprise- we are already INSIDE virtualmake!!!
797 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
798 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
799 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
800 debug-print " kde4-base.eclass docs for details... Applying workaround."
801 _test_runner
802 else
803 VIRTUALX_COMMAND="_test_runner" virtualmake
804 fi
805 else
806 _test_runner
807 fi
808
809 if [ -n "${kded4_pid}" ] ; then
810 kill ${kded4_pid}
811 fi
812
813 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
814 kill ${DBUS_SESSION_BUS_PID}
815 fi
565} 816}
566 817
567# @FUNCTION: kde4-base_src_install 818# @FUNCTION: kde4-base_src_install
568# @DESCRIPTION: 819# @DESCRIPTION:
569# Function for installing KDE4 applications. 820# Function for installing KDE4 applications.
572 823
573 if [[ -n ${KMSAVELIBS} ]] ; then 824 if [[ -n ${KMSAVELIBS} ]] ; then
574 install_library_dependencies 825 install_library_dependencies
575 fi 826 fi
576 827
577 kde4-base_src_make_doc 828 # Install common documentation of KDE4 applications
829 local doc
830 if ! has kde4-meta ${INHERITED}; then
831 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
832 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
833 done
834 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
835 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
836 done
837 fi
838
578 cmake-utils_src_install 839 cmake-utils_src_install
579}
580 840
581# @FUNCTION: kde4-base_src_make_doc 841 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
582# @DESCRIPTION: 842 # because then khelpcenter can't find the docs
583# Function for installing the documentation of KDE4 applications. 843 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
584kde4-base_src_make_doc() { 844 docompress -x ${PREFIX}/share/doc/HTML
585 debug-print-function ${FUNCNAME} "$@" 845}
586 846
587 local doc 847# @FUNCTION: kde4-base_pkg_preinst
588 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 848# @DESCRIPTION:
589 [[ -s ${doc} ]] && dodoc ${doc} 849# Function storing icon caches
590 done 850kde4-base_pkg_preinst() {
851 debug-print-function ${FUNCNAME} "$@"
591 852
592 if [[ -z ${KMNAME} ]]; then 853 gnome2_icon_savelist
593 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do 854 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
594 if [[ -s ${doc} ]]; then 855 subversion_pkg_preinst
595 local doc_complete=${doc}
596 doc="${doc#*/}"
597 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
598 fi
599 done
600 fi
601
602 if [[ -n ${KDEBASE} ]] && [[ -d "${D}${ROOT}usr/share/doc/${PF}" ]]; then
603 # work around bug #97196
604 dodir /usr/share/doc/KDE4 && \
605 mv "${D}${ROOT}usr/share/doc/${PF}" "${D}${ROOT}usr/share/doc/KDE4/" || \
606 die "Failed to move docs to KDE4/."
607 fi 856 fi
608} 857}
609 858
610# @FUNCTION: kde4-base_pkg_postinst 859# @FUNCTION: kde4-base_pkg_postinst
611# @DESCRIPTION: 860# @DESCRIPTION:
612# Function to rebuild the KDE System Configuration Cache after an application has been installed. 861# Function to rebuild the KDE System Configuration Cache after an application has been installed.
613kde4-base_pkg_postinst() { 862kde4-base_pkg_postinst() {
614 debug-print-function ${FUNCNAME} "$@" 863 debug-print-function ${FUNCNAME} "$@"
615 864
865 gnome2_icon_cache_update
866 fdo-mime_desktop_database_update
867 fdo-mime_mime_database_update
616 buildsycoca 868 buildsycoca
617 869
618 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 870 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
871 if [[ ${KDE_BUILD_TYPE} = live ]]; then
619 echo 872 echo
620 einfo "WARNING! This is an experimental live ebuild of ${KMNAME:-${PN}}" 873 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
621 einfo "Use it at your own risk." 874 einfo "Use it at your own risk."
622 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 875 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
623 echo 876 echo
624 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then 877 fi
625 # warning about kdeprefix for non-live users 878 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
879 if [[ ${KDEBASE} != kde-base ]] && \
880 ! has_version 'kde-base/kdebase-runtime-meta' && \
881 ! has_version 'kde-base/kdebase-startkde'; then
882 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
626 echo 883 echo
627 ewarn "WARNING! You have kdeprefix useflag enabled." 884 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
628 ewarn "This setting is strongly discouraged and might lead to potential troubles" 885 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
629 ewarn "with KDE update strategies." 886 ewarn "With this setting you are unsupported by KDE team."
630 ewarn "You are using this setup at your own risk and kde team does not" 887 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
631 ewarn "take responsibilities for dead kittens." 888 fi
632 echo 889 fi
633 fi 890 fi
634} 891}
635 892
636# @FUNCTION: kde4-base_pkg_postrm 893# @FUNCTION: kde4-base_pkg_postrm
637# @DESCRIPTION: 894# @DESCRIPTION:
638# Function to rebuild the KDE System Configuration Cache after an application has been removed. 895# Function to rebuild the KDE System Configuration Cache after an application has been removed.
639kde4-base_pkg_postrm() { 896kde4-base_pkg_postrm() {
640 debug-print-function ${FUNCNAME} "$@" 897 debug-print-function ${FUNCNAME} "$@"
641 898
899 gnome2_icon_cache_update
900 fdo-mime_desktop_database_update
901 fdo-mime_mime_database_update
642 buildsycoca 902 buildsycoca
643} 903}

Legend:
Removed from v.1.41  
changed lines
  Added in v.1.122

  ViewVC Help
Powered by ViewVC 1.1.20